"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractTask = void 0;
const rxjs_1 = require("@do-while-for-each/rxjs");
class AbstractTask {
    constructor(id) {
        this.id = id;
        this.allDataReceivedWrap = new rxjs_1.Subj({ type: 'shareReplay', bufferSize: 1 }, null);
        this.screenshotWrap = new rxjs_1.Subj({ type: 'shareReplay', bufferSize: 1 }, null);
        this.compareScreenshotWrap = new rxjs_1.Subj({ type: 'shareReplay', bufferSize: 1 }, null);
    }
    setAllDataReceived() {
        this.allDataReceivedWrap.setValue(true);
    }
    allDataReceived() {
        return __awaiter(this, void 0, void 0, function* () {
            return result(this.allDataReceivedWrap);
        });
    }
    setScreenshot(buf) {
        this.screenshotWrap.setValue(buf);
    }
    screenshot() {
        return __awaiter(this, void 0, void 0, function* () {
            return result(this.screenshotWrap);
        });
    }
    setCompareScreenshotResult(result) {
        this.compareScreenshotWrap.setValue(result);
    }
    compareScreenshotResult() {
        return __awaiter(this, void 0, void 0, function* () {
            return result(this.compareScreenshotWrap);
        });
    }
    stop() {
        this.allDataReceivedWrap.stop();
        this.screenshotWrap.stop();
        this.compareScreenshotWrap.stop();
    }
}
exports.AbstractTask = AbstractTask;
const result = (wrap) => __awaiter(void 0, void 0, void 0, function* () {
    return wrap.lastValue
        || wrap.value$.pipe(rxjs_1.filter(data => !!data), rxjs_1.first()).toPromise();
});
