"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AutomationEnvironment = void 0;
const playwright = __importStar(require("playwright"));
const dotenv_1 = require("dotenv");
const task_executor_1 = require("./task.executor");
const png_utils_1 = require("./png.utils");
class AutomationEnvironment {
    constructor(id, browser, options) {
        this.id = id;
        this.browser = browser;
        this.options = options;
        this.taskExecutor = new task_executor_1.TaskExecutor(this);
        this.pngUtils = new png_utils_1.PngUtils(this);
        this.storage = new options.storage.variant(this);
    }
    static of(options, id) {
        return __awaiter(this, void 0, void 0, function* () {
            dotenv_1.config(); // перенести переменные окружения в process.env
            const browser = yield playwright[options.browserType].launch(options.browser);
            yield browser.newContext(options.browserContext);
            return new AutomationEnvironment(id, browser, options);
        });
    }
    close() {
        var _a;
        if (!((_a = this.options.isLeaveOpen) === null || _a === void 0 ? void 0 : _a.env))
            this.browser.close();
        this.storage.clean();
    }
    get firstBrowserContext() {
        return this.browser.contexts()[0];
    }
    /**
     * New Tab.
     * Будут переиспользованы ранее произведенные авторизации на реусрсах, куки и т.п.
     */
    newPage() {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.firstBrowserContext.newPage();
        });
    }
    run(tasks) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.taskExecutor.run(tasks);
        });
    }
    debug(...args) {
        if (this.options.isDebug) {
            console.log(...args);
        }
    }
}
exports.AutomationEnvironment = AutomationEnvironment;
