"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Command = exports.defaultPixelmatchOptions = void 0;
// https://www.npmjs.com/package/pixelmatch#pixelmatchimg1-img2-output-width-height-options
exports.defaultPixelmatchOptions = {
    threshold: 0.1,
    includeAA: true,
    alpha: 0.1,
    diffColor: [0, 0, 255],
    diffColorAlt: [255, 0, 0],
    aaColor: [0, 165, 0],
    diffMask: false,
};
class Command {
    static screenshot(data = {}) {
        return { type: 'screenshot', data };
    }
    static get compareScreenshot() {
        return { type: 'compareScreenshot' };
    }
    static get newPage() {
        return { type: 'newPage' };
    }
    static get closePage() {
        return { type: 'closePage' };
    }
    static goto(data) {
        return { type: 'goto', data };
    }
    static wait(data) {
        return { type: 'wait', data };
    }
    static get waitForAllDataReceived() {
        return { type: 'waitForAllDataReceived' };
    }
    static click(data) {
        return { type: 'click', data };
    }
    static fill(data) {
        return { type: 'fill', data };
    }
    static mouseClick(data) {
        return { type: 'mouseClick', data };
    }
    static get login() {
        return { type: 'login' };
    }
}
exports.Command = Command;
//endregion
