"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PngUtils = void 0;
const pngjs_1 = require("pngjs");
const pixelmatch_1 = __importDefault(require("pixelmatch"));
const JPEG = __importStar(require("jpeg-js"));
const fs_1 = require("fs");
const contract_1 = require("./contract");
class PngUtils {
    constructor(env) {
        this.env = env;
    }
    read(path) {
        return pngjs_1.PNG.sync.read(fs_1.readFileSync(path));
    }
    readBuffer(buf) {
        return pngjs_1.PNG.sync.read(buf);
    }
    write(path, png) {
        fs_1.writeFileSync(path, pngjs_1.PNG.sync.write(png, { filterType: 4 }));
    }
    compare(origImg, imgToCompare) {
        const { width, height } = origImg;
        const diffImg = new pngjs_1.PNG({ width, height });
        const options = this.options.pixelmatch || contract_1.defaultPixelmatchOptions;
        const diffPixelsCount = pixelmatch_1.default(origImg.data, imgToCompare.data, diffImg.data, width, height, options);
        return {
            isEqual: diffPixelsCount === 0,
            diffPixelsCount,
            origImg,
            imgToCompare,
            diffImg,
        };
    }
    compareBuf(origImgBuf, imgToCompareBuf) {
        const origImg = this.readBuffer(origImgBuf);
        const imgToCompare = this.readBuffer(imgToCompareBuf);
        return this.compare(origImg, imgToCompare);
    }
    toJpeg({ data, width, height }, quality = 100) {
        return JPEG.encode({ data, width, height }, quality);
    }
    //region Support
    get options() {
        return this.env.options;
    }
}
exports.PngUtils = PngUtils;
