/// <reference types="node" />
import { Page } from 'playwright';
import { IImgCompareResult, ITask, TCommand } from './contract';
export declare abstract class AbstractTask implements ITask {
    readonly id: string;
    private allDataReceivedWrap;
    private screenshotWrap;
    private compareScreenshotWrap;
    constructor(id: string);
    abstract getScript(): TCommand[];
    page?: Page;
    setAllDataReceived(): void;
    allDataReceived(): Promise<any>;
    setScreenshot(buf: Buffer): void;
    screenshot(): Promise<Buffer>;
    setCompareScreenshotResult(result: IImgCompareResult): void;
    compareScreenshotResult(): Promise<IImgCompareResult>;
    stop(): void;
}
//# sourceMappingURL=abstract.task.d.ts.map