import { Browser, BrowserContext, Page } from 'playwright';
import { IAutomationEnvironmentOptions, IStorage, ITask } from './contract';
import { TaskExecutor } from './task.executor';
import { PngUtils } from './png.utils';
export declare class AutomationEnvironment {
    readonly id: string;
    readonly browser: Browser;
    readonly options: IAutomationEnvironmentOptions;
    static of(options: IAutomationEnvironmentOptions, id: string): Promise<AutomationEnvironment>;
    readonly taskExecutor: TaskExecutor;
    readonly pngUtils: PngUtils;
    readonly storage: IStorage;
    constructor(id: string, browser: Browser, options: IAutomationEnvironmentOptions);
    close(): void;
    get firstBrowserContext(): BrowserContext;
    /**
     * New Tab.
     * Будут переиспользованы ранее произведенные авторизации на реусрсах, куки и т.п.
     */
    newPage(): Promise<Page>;
    run(tasks: ITask[]): Promise<void>;
    debug(...args: any[]): void;
}
//# sourceMappingURL=automation.environment.d.ts.map