/// <reference types="node" />
import { PNG, PNGWithMetadata } from 'pngjs';
import { RawImageData } from 'jpeg-js';
import { IImgCompareResult } from './contract';
import { AutomationEnvironment } from './automation.environment';
export declare class PngUtils {
    env: AutomationEnvironment;
    constructor(env: AutomationEnvironment);
    read(path: string): PNGWithMetadata;
    readBuffer(buf: Buffer): PNGWithMetadata;
    write(path: string, png: PNG): void;
    compare(origImg: PNG, imgToCompare: PNG): IImgCompareResult;
    compareBuf(origImgBuf: Buffer, imgToCompareBuf: Buffer): IImgCompareResult;
    toJpeg({ data, width, height }: PNG, quality?: number): RawImageData<Buffer>;
    private get options();
}
//# sourceMappingURL=png.utils.d.ts.map