import { IInterception, ITask } from './contract';
import { AutomationEnvironment } from './automation.environment';
/**
 * Каждый из перехватов(match) по умолчанию отработает только один раз(onePass = true).
 * Такой подход позволяет контролировать момент передачи данных браузеру по всем перехватам.
 * Эта возможность используется в команде 'waitForAllDataReceived'.
 *
 * В зависимости от настроек задачи, в результате конкретного перехвата браузеру будет отдан:
 *   .) либо ответ сервера
 *       - и при необходимости сохранен в хранилище
 *   .) либо mock
 */
export declare class ReqInterceptor {
    private task;
    private env;
    private onePass;
    private interceptions;
    constructor(task: ITask, env: AutomationEnvironment, onePass?: boolean);
    register(data: IInterception[]): void;
    private getInterceptor;
    private getResponse;
    private getMock;
    private requestToServer;
    private saveResponse;
    private setCompleted;
    private completeInterception;
    private checkAllDataReceived;
    private get page();
    private get storage();
    private debug;
}
//# sourceMappingURL=req.interceptor.d.ts.map